__gnu_debug::_Safe_forward_list< _SafeSequence >(3cxx)

NAME
__gnu_debug::_Safe_forward_list< _SafeSequence > - Special iterators swap and invalidation for forward_list because of the before_begin iterator.

SYNOPSIS

Inherits __gnu_debug::_Safe_sequence< _SafeSequence >.

Inherited by __gnu_debug::_Safe_container< forward_list< _Tp, std::allocator< _Tp > >, std::allocator< _Tp >, __gnu_debug::_Safe_forward_list >.

  Public Member Functions

void _M_invalidate_if (_Predicate __pred)
void _M_transfer_from_if (_Safe_sequence &__from, _Predicate __pred)

  Public Attributes

_Safe_iterator_base * _M_const_iterators
The list of constant iterators that reference this container.
_Safe_iterator_base * _M_iterators
The list of mutable iterators that reference this container.
unsigned int _M_version
The container version number. This number may never be 0.

  Protected Member Functions

void _M_detach_all ()
void _M_detach_singular ()
__gnu_cxx::__mutex & _M_get_mutex () throw ()
void _M_invalidate_all ()
void _M_invalidate_all () const
void _M_revalidate_singular ()
void _M_swap (_Safe_sequence_base &) noexcept

Detailed Description

  template<typename _SafeSequence>
class __gnu_debug::_Safe_forward_list< _SafeSequence >" Special iterators swap and invalidation for forward_list because of the before_begin iterator.

Definition at line 56 of file debug/forward_list.

Member Function Documentation

  void __gnu_debug::_Safe_sequence_base::_M_detach_all () [protected], [inherited]
Detach all iterators, leaving them singular.

Referenced by __gnu_debug::_Safe_sequence_base::~_Safe_sequence_base().

  void __gnu_debug::_Safe_sequence_base::_M_detach_singular () [protected], [inherited]
Detach all singular iterators.

Postcondition
    for all iterators i attached to this sequence, i->_M_version == _M_version.

  __gnu_cxx::__mutex& __gnu_debug::_Safe_sequence_base::_M_get_mutex () [protected], [inherited]
For use in _Safe_sequence.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

  void __gnu_debug::_Safe_sequence_base::_M_invalidate_all () const [inline], [protected], [inherited]
Invalidates all iterators.

Definition at line 256 of file safe_base.h.

References __gnu_debug::_Safe_sequence_base::_M_version.

  void __gnu_debug::_Safe_sequence< _SafeSequence >::_M_invalidate_if (_Predicate __pred) [inherited]
Invalidates all iterators x that reference this sequence, are not singular, and for which __pred(x) returns true. __pred will be invoked with the normal iterators nested in the safe ones.

Definition at line 117 of file safe_sequence.tcc.

  void __gnu_debug::_Safe_sequence_base::_M_revalidate_singular () [protected], [inherited]
Revalidates all attached singular iterators. This method may be used to validate iterators that were invalidated before (but for some reason, such as an exception, need to become valid again).

  void __gnu_debug::_Safe_sequence< _SafeSequence >::_M_transfer_from_if (_Safe_sequence< _SafeSequence > & __from, _Predicate __pred) [inherited]
Transfers all iterators x that reference from sequence, are not singular, and for which __pred(x) returns true. __pred will be invoked with the normal iterators nested in the safe ones.

Definition at line 125 of file safe_sequence.tcc.

Member Data Documentation

  _Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_const_iterators [inherited]

The list of constant iterators that reference this container.

Definition at line 197 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

  _Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_iterators [inherited]

The list of mutable iterators that reference this container.

Definition at line 194 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

  unsigned int __gnu_debug::_Safe_sequence_base::_M_version [mutable], [inherited]

The container version number. This number may never be 0.

Definition at line 200 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence_base::_M_invalidate_all().

Author

Generated automatically by Doxygen for libstdc++ from the source code.